#!/usr/bin/env python3
import requests, yaml, json, os

class octan(object):
    def __init__(self,nr=0):
        if nr == 0:
            self.confdir = '/home/ethanak/.octoprint/'
            self.port = 5000
            self.usb='/dev/ttyUSB98'
            self.profile='_default'
        elif nr == 1:
            self.confdir = '/home/ethanak/.octoprint2/'
            self.port = 5001
            self.usb='/dev/ttyUSB99'
            self.profile='miniptusa'
        else:
            raise Exception('Nie ma takiego numeru')
        self._apiKey=None

    @property
    def api(self):
        if not self._apiKey:
            conf = yaml.safe_load(open(os.path.join(self.confdir,'config.yaml')))
            self._apiKey = conf['api']['key']
        return self._apiKey

    def get(self,command):
        path = 'http://127.0.0.1:%d/api/%s' % (self.port, command)
        rc=requests.get(path, headers={
            'Host': 'localhost',
            'Content-Type': 'application/json',
            'X-Api-Key' : self.api})
        rc.raise_for_status()
        return json.loads(rc.content)

    def post(self, command, data):
        path = 'http://127.0.0.1:%d/api/%s' % (self.port, command)
        rc=requests.post(path, headers={
            'Host': 'localhost',
            'Content-Type': 'application/json',
            'X-Api-Key' : self.api},json=data)
        if rc.status_code == 204:
            return 'Command executed'
        rc.raise_for_status()
        return json.loads(rc.content)
        
        #return json.loads(rc.content)
    def connect(self):
        cnc = self.get('connection')
        state = cnc['current']['state']
        if state != 'Closed':
            return 'Already connected'
        jdata = {
            'port': self.usb,
            'printerProfile': self.profile,
            'command': 'connect'}
        rc=self.post('connection', jdata)

def connect(which=0):
    try:
        o=octan(which)
        rc=o.connect()
        return {
            'status': 'success',
            'result': rc
            }
    except Exception as e:
        return {
            'status': 'error',
            'result': str(e)
            }
        


